using System;
using Collections = System.Collections;

namespace VarekartotekApplication
{
    // definition af Vare (data og metoder der findes for hver enkelt vare-object
    public class Vare
    {
        // vare-objektes memory (datafelter)
        public int Varenr;
        public string Betegnelse;
        public int AntalPLager;
        public float SalgsEnhedsPris;			// aktuel excl. moms
        public float IndkbsEnhedsPris;			// aktuel excl. moms
        public string Enhed;
        public int SolgtAntal;
        public int IndkbtAntal;
        public int MinimumAntal;


        // constructor til brug for skabelse af nyt vare-object
        public Vare(int varenr, string betegnelse, int antalPLager,
                    float salgsEnhedsPris, string enhed, float indkbsEnhedsPris,
                    int solgtAntal, int indkbtAntal, int minimumAntal)
        {
            this.Varenr = varenr;
            this.Betegnelse = betegnelse;
            this.AntalPLager = antalPLager;
            this.SalgsEnhedsPris = salgsEnhedsPris;
            this.Enhed = enhed;
            this.IndkbsEnhedsPris = indkbsEnhedsPris;
            this.SolgtAntal = solgtAntal;
            this.IndkbtAntal = indkbtAntal;
            this.MinimumAntal = minimumAntal;
        }

        // metode for beregning af den salgsvrdien det samlede antal
        public double Salgsvrdi()
        {
            double salgsvrdi = this.AntalPLager * this.SalgsEnhedsPris;
            return salgsvrdi;
        }

        // metode for beregning af den indkbsvrdien det samlede antal
        public double Indkbsvrdi()
        {
            double indkbsvrdi = this.AntalPLager * this.IndkbsEnhedsPris;
            return indkbsvrdi;
        }

        // metode for registreing af et antal solgte enheder af dette vareobjekt
        public void RegistrerVarerSolgt(int antal)
        {
            this.SolgtAntal = this.SolgtAntal + antal;
            this.AntalPLager = this.AntalPLager - antal;
        }

        // metode for registreing af et antal indkbte enheder af dette vareobjekt
        public void RegistrerVarerIndkbt(int antal)
        {
            this.IndkbtAntal = this.IndkbtAntal + antal;
            this.AntalPLager = this.AntalPLager + antal;
        }
    }
}
