using System;
using Collections=System.Collections;

namespace VarekartotekApplication
{
	// definition af "Hoved-programmet" (data og metoder der findes i hovedprogrammet)
	public class VarekartotekConsoleApplication
	{
		// Application objectets memory (datafelter)
		Collections.ArrayList  varesamling;

		// opstarts metoden (constructor)
		public VarekartotekConsoleApplication()
		{
			this.varesamling = new Collections.ArrayList();	 // opret tom varesamling
			this.OpretTestVarer();									 // fyld data i 

            // De allerede testede metoder, der ikke er ndvendige for sidste test,
            // er her kommenteret ud, s de ikke udfres

            //this.UdskrivAlleVarer();								 // udskriv

            //// test af metode til at finde en vare
            //Console.WriteLine("");
            //Console.WriteLine("");
            //Console.WriteLine("");
            //Console.WriteLine("Fundet vare");
            //Vare v = this.FindVarePVarenr(1002);
            //this.UdskrivEnVare(v);  // genbrug metode til at udskrive en vare

            //// test af metode til beregning og udskrift af totale salgsvrdi for alle varer
            //Console.WriteLine("");
            //UdskrivTotalSalgsvrdi();

            //// test af metode til at registrere antal solgt for en vare
            //Console.WriteLine("");
            //Console.WriteLine("");
            //Console.WriteLine("Registrer antal solgt og kbt for vare 1002");
            //Vare v2 = this.FindVarePVarenr(1002);   // Frst fr vi fat p varen (v2)
            //this.UdskrivEnVare(v2);         // S udskriver vi lige fr ndring for kontrol
            //v2.RegistrerVarerSolgt(10);     // S registrer vi antal solg p varen (v2)
            //this.UdskrivEnVare(v2);         // S udskriver vi igen for kontrol
            //v2.RegistrerVarerIndkbt(50);   // S registrer vi antal kbt p varen (v2)
            //this.UdskrivEnVare(v2);         // S udskriver vi igen for kontrol


            this.UdskrivUnderMinimum();     // udskriv alle under minimum

            Console.ReadLine();										 // Pause - vent p return !!
		}

		// metode der opretter test varer
		public void OpretTestVarer ()
		{
			varesamling.Add( new Vare (1001, "A4 blok ternet med huller", 10, 3.98f, "kasser", 3.68f, 30, 40, 100) );
			varesamling.Add( new Vare (1002, "A4 blok linieret med huller", 20, 3.88f, "boxe", 3.65f, 40, 60, 20) );
			varesamling.Add( new Vare (1003, "Blyant Viking 400x2", 110, 0.64f, "sker", 0.50f, 500, 620, 200) );
            varesamling.Add( new Vare (1004, "Blyant Viking 800x2", 210, 0.66f,"sker", 0.55f, 410, 615, 200) );
        }

        // metode der udskriver en oversigt over alle varer i samlingen
        public void UdskrivAlleVarer()
        {
            double totalSalgsvrdi = 0;
            double totalKbsvrdi = 0;
            Console.WriteLine("Vare oversigt");
            foreach (Vare vare in varesamling)
            {
                totalSalgsvrdi = totalSalgsvrdi + vare.Salgsvrdi();
                totalKbsvrdi = totalKbsvrdi + vare.Indkbsvrdi();
                this.UdskrivEnVare(vare);
            }
            Console.WriteLine("");
            Console.WriteLine("Total salgsvrdi " + totalSalgsvrdi);
            Console.WriteLine("Total indkbsvrdi " + totalKbsvrdi);
        }

        // metode der udskriver en oversigt over alle varer i samlingen,
        // hvor antal p lager er kommet under minimumsantallet
        public void UdskrivUnderMinimum()
        {
            double totalSalgsvrdi = 0;
            double totalKbsvrdi = 0;
            Console.WriteLine("Vare oversigt over varer der er under minimumsantal");
            foreach (Vare vare in varesamling)
            {
                if (vare.AntalPLager < vare.MinimumAntal)  // test om under minimum
                {
                    this.UdskrivEnVare(vare);
                }
            }
            Console.WriteLine("");
        }

        // metode der udskriver en den totale salgsvrdi for alle varer i samlingen
        public void UdskrivTotalSalgsvrdi()
        {
            double totalSalgsvrdi = 0;
            foreach (Vare vare in varesamling)
            {
                totalSalgsvrdi = totalSalgsvrdi + vare.Salgsvrdi();
            }
            Console.WriteLine("Beregnet totale salgsvrdi for alle varer " + totalSalgsvrdi);
        }

        // metode der finder en vare i varesamlingen ud fra et varenr og returnere den fundne vare
        public Vare FindVarePVarenr(int varenr)
        {
            foreach (Vare vare in varesamling)
            {
                if (vare.Varenr == varenr)  // test om vare har det nskede varenr
                    return vare;            // gevinst - vi returnere med den fundne
            }
            return null;  // vi har vret alle varer igennen uden held og returnere null-reference
        }

		// metode der udskriver en enkelt vare, der angives som input-parameter
		public void UdskrivEnVare (Vare vare)
		{
			Console.WriteLine("--------------------------------------------------");
			Console.WriteLine("Varenr: " + vare.Varenr);
			Console.WriteLine("Betegnelse: " + vare.Betegnelse);
			Console.WriteLine("Antal enheder p lager: " + vare.AntalPLager);
			Console.WriteLine("Salgsvrdi: " + vare.Salgsvrdi() );//NB: metodekald
            Console.WriteLine("Salgspris pr. enhed" + vare.SalgsEnhedsPris);
            Console.WriteLine("Indkbspris pr. enhed" + vare.IndkbsEnhedsPris);
            Console.WriteLine("Indkbsvrdi: " + vare.Indkbsvrdi());//NB: metodekald
            Console.WriteLine("Antal solgte enheder: " + vare.SolgtAntal);
            Console.WriteLine("Antal indkbte enheder: " + vare.IndkbtAntal);
            Console.WriteLine("Minimums antal: " + vare.MinimumAntal);
        }
	}

}
